/* *****************************************************************************
  HD4470n(SC1602BS*B) tW[pR[h
  Kusunokî̂ꕔύX
  kuman̂̂ꕔύX
  '061216  f[^̃rbgwLɂ   (by )
  '070112  MSP430pɂ   (by )
  '070114  Busy`FbNǉ   (by )

 RpCFTI MSP430p IAR Embedded Workbench iEW430jo[W3.41
******************************************************************************* */
#include "msp430x42x0.h"
#include "lcd.h"

uint8_t columns;
uint8_t lines;
uint8_t busy_check;

void lcd_delay(uint16_t wait_msec) {
  uint16_t i,w;
  for(w =0; w<wait_msec; w++){
    for(i = 0; i<1000; i++) {  //1msec̑҂ԁACPŨNbNɂ킹ĕύXKv
      asm("NOP");              //œKɂĂ̓[v폜̂h
    }
  }
}

void lcd_busy(void) {
/* volatile */uint8_t busy,wk;
  
  LCD_DATA_PORT_DDR &= ~(_BV(LCD_D7) | _BV(LCD_D6) | _BV(LCD_D5) | _BV(LCD_D4));//DATA PORT DIR:INPUT
  LCD_CTL_PORT&=~_BV(LCD_RS);   // RS = Low
  LCD_CTL_PORT|=_BV(LCD_RW);    // RW = Hi
  
  do{
    LCD_CTL_PORT|=_BV(LCD_E);   // E = Hi
    wk=LCD_DATA_IN_PORT;        // ̓|[gǂł(ʂSrbg)
    LCD_CTL_PORT&=~_BV(LCD_E);  // E = Low
    busy=0;
    busy|=((wk & _BV(LCD_D7))!=0) ? 0x80:0;
    LCD_CTL_PORT|=_BV(LCD_E);   // E = Hi
    wk=LCD_DATA_IN_PORT;        // ̓|[gǂł(ʂSrbg)
    LCD_CTL_PORT&=~_BV(LCD_E);  // E = Low
  }while(busy!=0);
  
  LCD_CTL_PORT&=~_BV(LCD_RW);   // RW = Low
  LCD_DATA_PORT_DDR |= _BV(LCD_D7) | _BV(LCD_D6) | _BV(LCD_D5) | _BV(LCD_D4);//DATA PORT DIR:OUTPUT
}

void lcd_e(void) {//ẼpX230nsecȏKvA3.3VȂ̂łƕKviKvɉNOPĂj
  LCD_CTL_PORT|=_BV(LCD_E);     // E = Hi
  asm("NOP");
  asm("NOP");
  asm("NOP");
  LCD_CTL_PORT&=~_BV(LCD_E);    // E = Low
}

void lcd_cls(void) {
  columns = lines = 0;
  lcd_putcmd((uint8_t)0x01);
}

void lcd_gotopos(uint8_t col,uint8_t lin) {

  switch(lin) {
  case 0: lcd_putcmd((uint8_t)(0x80 + col)); break;
  case 1: lcd_putcmd((uint8_t)(0xC0 + col)); break;
  }
  columns = col;
  lines = lin;
}

void lcd_setpos(void) {
  columns = 0;
  switch(++lines) {
  case 2: lines = 0; lcd_putcmd(0x80); break;
  case 1:            lcd_putcmd(0xC0); break;
  }
}

void lcd_cmdout_s(uint8_t cmd) {
  uint8_t wk;

  if(busy_check==1){
//    lcd_busy();//busy`FbN
  }

  LCD_CTL_PORT&=~_BV(LCD_RS);   // RS = Low
  LCD_CTL_PORT&=~_BV(LCD_RW);   // RW = Low
  wk=LCD_DATA_PORT;             // o̓|[gǂł

  wk &= ~(_BV(LCD_D7) | _BV(LCD_D6) | _BV(LCD_D5) | _BV(LCD_D4));//f[^rbgNA
  wk |= ((cmd & 0x1)==0x1) ? _BV(LCD_D4):0;//bit4
  wk |= ((cmd & 0x2)==0x2) ? _BV(LCD_D5):0;//bit5
  wk |= ((cmd & 0x4)==0x4) ? _BV(LCD_D6):0;//bit6
  wk |= ((cmd & 0x8)==0x8) ? _BV(LCD_D7):0;//bit7

  LCD_DATA_PORT=wk;
  lcd_e();
  
  if(busy_check==1){
    lcd_busy();//busy`FbN
  }
}

void lcd_putcmd(uint8_t cmd) {
  lcd_cmdout_s(cmd >> 4);
  lcd_cmdout_s(cmd & 0x0F);
}

void lcd_dataout_s(uint8_t ch) {
  uint8_t wk;
  LCD_CTL_PORT|=_BV(LCD_RS);    // RS = Hi
  LCD_CTL_PORT&=~_BV(LCD_RW);   // RW = Low
  wk=LCD_DATA_PORT;             // o̓|[gǂł

  wk &= ~(_BV(LCD_D7) | _BV(LCD_D6) | _BV(LCD_D5) | _BV(LCD_D4));//f[^rbgNA
  wk |= ((ch & 0x1)==0x1) ? _BV(LCD_D4):0;//bit4
  wk |= ((ch & 0x2)==0x2) ? _BV(LCD_D5):0;//bit5
  wk |= ((ch & 0x4)==0x4) ? _BV(LCD_D6):0;//bit6
  wk |= ((ch & 0x8)==0x8) ? _BV(LCD_D7):0;//bit7

  LCD_DATA_PORT=wk;
  lcd_e();
}

void lcd_putch(uint8_t ch) {
  lcd_dataout_s(ch >> 4);
  lcd_dataout_s(ch & 0x0F);
  if(++columns == LCD_COL) {
    lcd_setpos();
  }
}

void lcd_putstr(uint8_t *str) {
  while(*str) {
    lcd_putch(*str++);
  }
}

void lcd_init(void) {

  busy_check = 0;//Srbg[hɂȂ܂busy`FbNȂ
  
  LCD_DATA_PORT_DDR |= _BV(LCD_D7) | _BV(LCD_D6) | _BV(LCD_D5) | _BV(LCD_D4);//DATA PORT DIR:OUTPUT
  LCD_CTL_PORT_DDR  |= _BV(LCD_E) | _BV(LCD_RW) | _BV(LCD_RS);//CONTROL PORT DIR:OUTPUT

  lcd_delay(15);//15msec WAIT

  LCD_CTL_PORT&=~_BV(LCD_RS);   // RS = Low
  LCD_CTL_PORT&=~_BV(LCD_E);    // E  = Low
  LCD_CTL_PORT&=~_BV(LCD_RW);   // RW = Low DATA͏CPULCDւ݂̏ɂĂ܂

  lcd_cmdout_s(0x03);
  lcd_delay(4);//4.1msec WAIT
  lcd_cmdout_s(0x03);
  lcd_delay(1);//100usec WAIT
  lcd_cmdout_s(0x03);
  lcd_delay(1);

  busy_check = 1;//ȍ~busy`FbN
 
  lcd_cmdout_s(0x02);
  lcd_putcmd(0x28);
  lcd_putcmd(0x08);
  lcd_putcmd(0x01);
  lcd_putcmd(0x0C);
  columns = 0;
  lines = 0;
}
