//******************************************************************************
//  MSP430F4270 fE\tg
//
//  |[OSD16_Aϊʂ擾, `l6(x), j|[ϊ
//
//  HSC1602LCDɉx\܂iIWiFgZ2007.1t^CD-ROM, SD16_DC_Fj
//
//  RpCFTI MSP430p IAR Embedded Workbench iEW430jo[W3.41
//******************************************************************************

#include "msp430x42x0.h"
#include "stdio.h"
#include "lcd.h"

const float Voffset = 6.2;
const float TC = 1.32;

float T;

//unsigned short AD_DAT[32];
long sum;
float V6;

//  1ms~datԑ҂ٰ
void t1ms(unsigned short dat)             // Basic Timer1
{
  unsigned short j;
  unsigned long i;

  i = 32.768 * dat - 22;                  // ACLK(32.768kHz)o߃JEgvZ
                                          // 22͎Ԓp(MCLK̒lŕς)
  do
  {
    j = BTCNT1;                           // j͉ʂ̃JE^l
    while(BTCNT1 == j);                   // BTCNT1JEgAbv܂ő҂
    i--;                                  // iPJEg
  }while (i != 0);                        // i=0(^CAbv)܂ŌJԂ
}

//LCD\
void disp(int dat)
{
  uint8_t str[17];
  int wk = dat;
  if(wk<0) wk = -wk;
  
  sprintf((char *)str,"temp=%d.%02dc",dat/100,wk%100);
  lcd_cls();
  lcd_putstr(str);
}

//main
void main(void)
{
  int i;

  WDTCTL = WDTPW + WDTHOLD;               // WDT̒~
//  SCFQCTL = 94 - 1;                       // MCLK = 94 * ACLK * 2 = 6.16MHz, D = 2
  FLL_CTL0 = /*DCOPLUS +*/ XCAP18PF;          // DCOPLUS = 1, eʕׂ18pF
//  SCFI0 = FLLD_2 + FN_2;                  // D = 2, fDCOCLK =   2.2-17Mhz

  BTCTL = BT_ADLY_2000;                   // Basic Timer̃NbNACLK/256

  lcd_init();
  lcd_cls();
  
  SD16CTL = SD16VMIDON + SD16REFON + SD16SSEL_1 + SD16DIV_1 + SD16XDIV_1; //@ccc@
      // VMID I, 1.2V refI, SMCLK, /4, /16  fM = 6.16MHz / 4 / 16 = 96.256kHz
  t1ms(1);                                // 1ms҂FVref[q̃RfT[d҂@cccA
  SD16CTL &= ~SD16VMIDON;                 // VMID It@cccB

  SD16CCTL0 =  SD16BUF_1 + SD16UNI + SD16OSR_1024;  //@cccC
            // Int disable, j|[, OSR = 1024
  SD16INCTL0 = SD16INTDLY_0 + SD16GAIN_1 + SD16INCH_6;  //@cccD
            // 4ڂ犄, PGA̗1, `l6(xZT)
  do
  {
    SD16CCTL0 |= SD16SC;                    // ADϊJn@cccE
    sum = 0;
    for (i = 0; i < 64; i++)
    {
      while ((SD16CCTL0 & SD16IFG) == 0);   // ϊI҂@cccF
      sum = sum + SD16MEM0;
    }
    SD16CCTL0 &= ~SD16SC;                   // ADϊ~@cccH
    V6 = sum / 64. / 65535. * 600.;
    T = (V6 - Voffset) / TC - 273.;
    disp(T * 100);
  }while(1);
 
}
